/*** CALCULETTE PROGRAMMABLE (style Maple):
 decompcalc.l:
   auteur : PFZ
   version origine: Mars 1999 avec l'aide de J. Farre'
   nouvelle version: Mars 2000 avec l'aide de T. Graf
       supporte un affichage semi-graphique et un dialogue

--------------------------------------------------------
version actuelle: NOV 2005
*********************************************************/

%{
#include "dparse.h" // le nom est celui utilis dans le makefile

int lig=1;  // la ligne courante du source
char LIGNE[100], DERNLIGNE[100] ;
extern int ERREUR ;
void echoClavier() {
        sprintf(LIGNE, "%s%s", LIGNE, yytext);
}
%}
ESP     (" "|\t)
LMAJ 	[A-Z]
LMIN 	[a-z]
C	[0-9]
a       [a|A]
b       [b|B]
c       [c|C]
d       [d|D]
e       [e|E]
f       [f|F]
g       [g|G]
h       [h|H]
i       [i|I]
l       [l|L]
n       [n|N]
m       [m|M]
o       [o|O]
p       [p|P]
q       [q|Q]
r       [r|R]
s       [s|S]
t       [t|T]
u       [u|U]
x       [x|X]
y       [y|Y]
z       [z|Z]

%%
{s}{t}{o}{p} |
{f}{i}{n}    |
{b}{y}{e}    |
{c}{i}{a}{o} |
{e}{x}{i}{t} |
{q}{u}{i}{t}     echoClavier(); return STOP;

{m}{e}{n}{u} |
{h}{e}{l}{p}     echoClavier(); return MENU;


{c}{l}{e}{a}{r}  sprintf(LIGNE, "%s%s ", LIGNE, yytext); return CLEAR ;

{p}{a}{u}{s}{e}  sprintf(LIGNE, "%s%s ", LIGNE, yytext); return PAUSE ;

{r}{e}{s}{e}{t}  echoClavier(); return RESET;

{s}{u}{m}        echoClavier(); return SUM;
{f}{r}{o}{m}     echoClavier(); return FROM;
{t}{o}           echoClavier(); return TO;
{b}{y}           echoClavier(); return BY;

#{p}{i}          echoClavier(); return PI;
#{e}             echoClavier(); return E;
{s}{i}{n}        echoClavier(); return SINUS; 
{c}{o}{s}        echoClavier(); return COSINUS;
{l}{o}{g}        echoClavier(); return LOG;
{s}{q}{r}{t}     echoClavier(); return SQRT;
"$"              echoClavier(); return DERNIER;

{C}+	  		{yylval.att.val=atoi(yytext); echoClavier(); return ENT;}
{C}+\.{C}* |
{C}*\.{C}+  	{yylval.att.val=atof(yytext); echoClavier(); return REEL;}
{LMIN}          {yylval.att.let=yytext[0]; echoClavier();  return VAR; }
{LMAJ}          {yylval.att.let=yytext[0]+32; echoClavier(); return VAR; }
{ESP}			;                   /* a ignorer */
\n				{
                lig++; 
                if(!ERREUR){okStyle(); aff_dialogue(LIGNE); }
		sprintf(DERNLIGNE, "%s", LIGNE); // pour afficher la dernire ligne 
                sprintf(LIGNE, ""); // pour effacer la ligne (future) courante
                return FINDELIGNE;
                }

\!		echoClavier(); return yytext[0]; /* l'oprateur FAC ou NOT  ? */
{c}/{ESP}*"("		echoClavier(); return CNP; /* l'oprateur CNP */

.	        {echoClavier(); if(yytext[0]>0) return yytext[0];} /* les operateurs et le reste, mais on masque les tendus */

%%
/* flush pour yylex() */
int yywrap() { printf("\n");return 0;}
