/*** CALCULETTE PROGRAMMABLE (style Maple):
   Syntaxe LALR(1)
   Evaluation par un (doublet) attribut synthetise $
   auteur : PFZ
   version origine: Mars 1999 avec l'aide de J. Farre'
   nouvelle version: Mars 2000 avec l'aide de T. Graf
   nouvelle version 2001: 
   
   **** version 1 pour dbuter plus facilement *******
 
Versions et MODIFS pour la (super)Calculette
_______________________________________________

pour 2000:
- ajout de la dcompilation du source
- nouveau makefile
- nouvelle version de l'affichage et dialogue

pour 2001: 
- grammaire E+E avec priorit
- accepter les Var avec Majuscules (transposes en minuscules par lex)

pour 2002:
- utiliser la grammaire ETF + Primaire pour - unaire et ^ 
- type abstrait pour la memoire REGISTRES avec setV et getV
- revoir le rcupration d'erreurs, insuffisante pour les regles basses de la grammaire
- decompilation via HTML ?
- IHM via java ?

*********************************************************/

/* declarations YACC *************/
%union {          /* le doublet d'attributs YACC */
    double val ;
    char let ;
}
%token <val> ENT DERNIER
%token <let> VAR
%token FINDELIGNE CLEAR RESET STOP SUM FROM TO BY SINUS COSINUS PI
%type <val> exp 
%left '+' '-'
%left '*' '/'
%left '^'
%left UMOINS
%{
#include <math.h> /* ajouter -lm au link */
#include <stdio.h>

#include "affichage.h"

#include "memoire.h"

%}
/***** DEBUT des actions YACC ****/
%%
calc   : ligne
       | calc ligne
       ;

ligne  : error  FINDELIGNE
		{yyerrok; lig -= 1;
                  Mon_yyerror ("erreur de syntaxe");}
       | FINDELIGNE
		{
                aff_dialogue("?");
		}
       |  exp FINDELIGNE
		{
		aff_exp($1);
		}
       |  STOP  FINDELIGNE
                {
		 aff_dialogue(" Au revoir\n");

                YYACCEPT ;}
       ;

exp    :  exp '+' exp
		             {$$ = $1 + $3 ;}
       |  exp '-' exp
		             {$$ = $1 - $3 ;}
       |  exp '*' exp
		             {$$ = $1 * $3 ;}
       |  exp '/' exp
                             { if ($3 == 00) {
	                             Mon_yyerror("division par zero");
			             $$ = 999999;
			          } else
			          $$ = $1 / $3 ;
			     }
       | '(' exp ')'
                        	{$$ = $2 ;}
       | exp '^' exp
                        	{$$ = pow($1, $3) ;}
       | '-' exp %prec UMOINS
                        	{$$ = -$2 ;}
       | ENT
                                {$$ = $1 ;}   
       ;



%%

extern int lig;

int yyparse();

int yyerror(char *s)   /* pour masquer les messages de yacc */
{
  /* printf("ligne %d : %s\n",lig,s); */
  return 1;
}

int Mon_yyerror(char *s) /* pour masquer celui de yacc */
{
  aff_erreur(lig, s);
  return 1;
}

int main() {
  dessine_calculette();

  return yyparse();
}

