/*** SUPER CALCULETTE: Affichage.c
 
   auteur : PFZ
   version origine: Mars 1999 avec l'aide de J. Farre'
   nouvelle version: Mars 2000 avec l'aide de T. Graf
   nouvelle version 2001: 
 
   version actuelle: 2 NOV 2005


   styles du curseur:etats booleens Gras Souligne' et Reverse 
   S est renomme' U a cause d'un conflit avec un S plus bas 
******************************************************************/

#include <stdio.h>
#include "LIB/graphique.h"


/*
 * fonction d'encadrement par un cadre rectangulaire:
 * 2 verticales colonnes 0 et d, 2 horizontales ligne courante et courante-h
 */
void encadre(int d, int h) {
  int i;

  reverse();
  haut(h+1); /* curseur vers le haut de h+1 lignes */

  /* trait du haut */
  printf(" ");
  for (i = 1; i < d; i++) {
    printf(" ");
  }
  printf(" ");

  for (i = 1; i < h+1; i++) {
    printf("\n "); av(d-1); printf(" "); /* curseur vers l'avant de d-1 cols */
  }

  /* trait du bas */
  printf("\n ");
  for (i = 1; i < d; i++) {
    printf(" ");
  }
  printf(" ") ;
  non_reverse();
}

void texte_en_gras(char* s) {
  gras(); printf("%s",s); non_gras();
}

void erreurStyle() {
  rouge(); gras();
}

void okStyle() {
  bleu(); 
}

extern int ERREUR;
int ligSource=1; // la ligne du source peut diffrer de l'entre  cause des erreurs

/***** affichage du decor de la calculette ******/
int XECRAN = 2, YECRAN = 2, WECRAN = 31;		/* origine X,Y et Larg de l'ecran */
int XCLAVIER = 30, YCLAVIER = 1, WCLAVIER = 65;		/* origine X,Y et Larg du Clavier */
int XMESSAGE= 6, YMESSAGE= 2, WMESSAGE= 31;	    	/* origine X,Y et Larg du Message */
int XMENU = 10, YMENU = 1;				/* origine X,Y du Menu */
int XVARIABLES = 2, YVARIABLES = 38, WVARIABLES = 12;	/* origine X,Y et Larg du tableau des variables */
int XSOURCE = 2, YSOURCE = 38+19, WSOURCE = 35 ;	/* origine X,Y et Larg du texte source */
int XFIN = 34;                          		/* pour rejeter le curseur  la fin */

void clearTexte(int L) {  /* efface le texte precedent sur la longueur L */
   int	i;
   for (i=0; i<L; i++) {printf(" ");}
   // printf("1234");
}

void auRevoir(char* s) {
  goto_xy(XFIN, 2); okStyle(); texte_en_gras(s); std() ;
}

void aff_les_variables() {
  int	i;
  goto_xy(XVARIABLES-1,YVARIABLES);
  printf("**** VARIABLES ****");
  for (i=0; i<26; i++) {
    goto_xy(XVARIABLES+i,YVARIABLES); 
    printf("* %c = 0           L", 'a'+i);
  }                                        
}

void aff_menu(int complet) {
  goto_xy(XMENU, YMENU ); 
  printf("************* MENU ****************\n");
  if (complet) {
  printf("EXP: sur des entiers               \n");
  printf("     et/ou des VARIABLES           \n");
  printf("     et/ou #pi, #e, $              \n");
  printf("     et/ou des FONCTIONS           \n");
  printf("VAR: une seule lettre              \n");
  printf("OP ARITHM: + - * / ^ -(unaire) ( ) \n");
  printf("OP COND: < <= > >= = !=            \n");
  printf("AFFECTATION: VAR = EXP             \n");
  printf("FONCTIONS: sin(),cos(),sqrt(),log()\n");
  printf("CONDITIONELLE: (COND ? EXP:EXP)    \n");
  printf("SOMMES: (from EXP to EXP sum EXP)  \n");
  printf("(from EXP to EXP by EXP sum EXP)   \n");
  printf("REMISE A ZERO: clear v, reset      \n");

  printf("------- extensions prvues --------\n");
  printf(" n!, C(n,p), Fib(n), Cat(n)        \n");
  printf(" ++var, --var, var++, var--        \n");
  printf("PAUSE(pour les demos): pause n     \n");
  }
  else printf("Le MENU complet: menu|help\n");
  printf("-----------------------------------\n");
  printf("SORTIE:exit|stop|quit|bye|fin|ciao \n");
}

void prompteur(int l, char* s) {
  goto_xy(XCLAVIER+1,YCLAVIER+2); clearTexte(WCLAVIER); /* efface le precedent*/
  goto_xy(XCLAVIER+1,YCLAVIER+2); 
  okStyle(); gras(); printf("L%d%s", l, s); std();
}

void dessine_calculette() {
  clear(); std();
  aff_les_variables(); 
  aff_menu(0);

  /*dcalc*/
  goto_xy(XSOURCE-1, YSOURCE);
  printf("***** DECOMPILATION DU SOURCE *****");
  /*end dcalc*/
  goto_xy(XECRAN,YECRAN) ;
  printf("************** ECRAN *************");
  goto_xy(XECRAN+1,YECRAN) ;
         printf("*                                *");
  goto_xy(XECRAN+2,YECRAN) ;
         printf("*                                *");
  goto_xy(XECRAN+3,YECRAN) ;
         printf("*                                *");
  goto_xy(XECRAN+4,YECRAN) ;
         printf("* -----------messages----------- *");
  goto_xy(XECRAN+5,YECRAN) ;
         printf("*                                *");
  goto_xy(XECRAN+6,YECRAN) ;
         printf("**********************************");
  
  goto_xy(XCLAVIER,YCLAVIER) ;
  printf("************** CLAVIER *********************************************");
  goto_xy(XCLAVIER+1,YCLAVIER) ;
  printf("*                                                                  *");
  goto_xy(XCLAVIER+2,YCLAVIER) ;
  printf("********************************************************************");
}

void aff_affect(char id , double val) {
  goto_xy(XECRAN+2,YECRAN+2) ; clearTexte(WECRAN); /* efface le precedent*/
  goto_xy(XECRAN+2,YECRAN+2) ; 
  okStyle(); printf("%c=%.2f",id, val); std();
}

void aff_exp(double val) {
  goto_xy(XECRAN+2,YECRAN+2) ; clearTexte(WECRAN); /* efface le precedent*/
  goto_xy(XECRAN+2,YECRAN+2) ; 
  okStyle(); printf("=%.2f", val); std();
}

void aff_clear(char id){
  goto_xy(XECRAN+2,YECRAN+2) ; clearTexte(WECRAN); /* efface le precedent*/
  goto_xy(XECRAN+2,YECRAN+2) ; 
  okStyle(); printf("%c=0", id); std();
}

void aff_dialogue(char* mess) {
  goto_xy(XMESSAGE+1, YMESSAGE+2) ; clearTexte(WECRAN); /* efface le precedent*/
  goto_xy(XMESSAGE+1, YMESSAGE+2) ; printf("%s",mess);
  
}

void aff_une_variable(char c, double val) {
  goto_xy(XVARIABLES+(c-'a'), YVARIABLES+6); clearTexte(WVARIABLES); /* efface le precedent*/
  goto_xy(XVARIABLES+(c-'a'), YVARIABLES+6); okStyle(); reverse(); printf("%.3f", val);
  std();
}

void aff_erreur(int lig, char *s) {
  goto_xy(XMESSAGE+1, YMESSAGE+2) ; clearTexte(WECRAN);  /* efface le precedent*/
  goto_xy(XMESSAGE+1, YMESSAGE+2) ;
  erreurStyle();
  printf("ligne %d : %s  \n", lig-1, s);  ///?? fflush(stdout); 
  sleep(2); 
  aff_dialogue("retapez la ligne !\n"); std(); ///??  fflush(stdout);
}

void aff_source(int lig, char *s, char* err) {
  goto_xy(XSOURCE-1+ligSource,YSOURCE); clearTexte(WSOURCE);
  goto_xy(XSOURCE-1+ligSource++,YSOURCE); printf("%d: %s%s", lig, s, err); std() ;
  if (ERREUR) {ligSource--;}
}

/******************** FIN **********************************/
